/*********************************************************
 *Author: misteri0                                       *
 *E-mail: leet@ibw.com.ni                                *
 *Group Coded For: [outlaw]                              *
 *Description:                                           *
 *	 checks if finger service exists ane then fingers*
 *      root and prints out result                       *                              
 *Note: I plan to release one messala every week or so   *
 *********************************************************/
#define fingerd "root\n"
#define FINGERport 79
int finger(char *host)
{
  struct hostent *hp;
  struct in_addr addr;
  struct sockaddr_in s;
  u_char buf[1024];
  int p,i;
  
  memset(buf, 0, 1024);
   
  hp = gethostbyname (host);

  if (!hp) exit (1);

  bcopy (hp->h_addr, &addr, sizeof (struct in_addr));
  p = socket (s.sin_family = 2, 1, IPPROTO_TCP);
  s.sin_port = htons (FINGERport);
  s.sin_addr.s_addr = inet_addr (inet_ntoa (addr));
  #ifdef debugz
    printf("Trying to connect to finger port\n");
  #endif
  if(connect (p, &s, sizeof (s))!=0)
  {
  	#ifdef debugz
  		printf("Unable to connect to Fingerport (79)\n");
  	#endif
  	return;
  }
  else {
  signal(SIGALRM, handle_alarm);
  alarm(4);              /*Time out after 4 seconds */
  write(p, fingerd, 1024); /* <-- finger root */
 
  read (p, buf, 1024); /* Grab it all*/
  close(p);
  if(strstr(buf,"no such user"))
  {
  	#ifdef debugz
  		printf("No such user [finger]\n");
  	#endif
  	return;
  }
  else {
  
  printf(".:( messala tried to finger root account ):.\n");
  printf("Results:\n");
  printf("%s",buf);
  printf("\n.:( messala [Results from fingering root account] ):.\n");
  
   }

  
 }
 
return(0);
}