/*********************************************************
 *Author: misteri0                                       *
 *E-mail: leet@ibw.com.ni                                *
 *Group Coded For: [outlaw]                              *
 *Description:                                           *
 *	Scans for all known ftp vulns                    *
 *      (e-mail me if I missed a couple)                 *                              
 *Note: I plan to release one messala every week or so   *
 *********************************************************/

#define FTPPORT 21

int ftpvulnscan(char *host)
{
  struct hostent *hp;
  struct in_addr addr;
  struct sockaddr_in s;
  u_char buf[280];
  int p, i;
  

  hp = gethostbyname (host);
  if (!hp) exit (1);

  bcopy (hp->h_addr, &addr, sizeof (struct in_addr));
  p = socket (s.sin_family = 2, 1, IPPROTO_TCP);
  s.sin_port = htons (FTPPORT);
  s.sin_addr.s_addr = inet_addr (inet_ntoa (addr));
  if(connect (p, &s, sizeof (s))!=0)
  {
    #ifdef debugz
      printf("Unable to Connect to Port 21\n");
    #endif
    return;
   }
   else {
  #ifdef debugz
   printf("Entering FTP check\n");
  #endif;
   signal(SIGALRM, handle_alarm);
   alarm(4);             /*Time out after 4 seconds */
  
  read (p, buf, 255);
  #ifdef debugz
   printf("Reading\n");
  #endif
  }
  if (strstr (buf,"wu-2.4.2-academ[BETA-18](1)"))
  {
        printf ("<[wu-2.4.2-academ[BETA-18](1)]> <-- Vulnerable (Overflow?)\n");

    }
  if (strstr (buf,"Version wu-2.5.0(1)"))
  {
	printf("<[wu-2.5.0(1)]> <-- Vulnerable (Overflow?)\n");
  }
  
  if (strstr (buf,"ProFTPD 1.2.0pre1"))
  {
	printf("<[ProFTPD 1.2.0pre1]> <-- Vulnerable (Overflow?)\n");
  }
    if (strstr (buf,"ProFTPD 1.2.0pre2"))
  {
	printf("<[ProFTPD 1.2.0pre2]> <-- Vulnerable (Overflow?)\n");
  }
    if (strstr (buf,"ProFTPD 1.2.0pre3"))
  {
	printf("<[ProFTPD 1.2.0pre3]> <-- Vulnerable (Overflow?)\n");
  }
   if(strstr (buf,"NcFTPd 2.4.3"))
   {
   	printf("<[NcFTPd 2.4.3]> <-- Vulnerable (Overflow?)\n");
   }
      if(strstr (buf,"NcFTPd 2.4.2"))
   {
   	printf("<[NcFTPd 2.4.2]> <-- Vulnerable (Overflow?)\n");
   }
 #ifdef debugz
 	printf("Leaving ftp check\n");
 #endif
 return(0);
}